Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.struts2.interceptor
Class FileUploadInterceptor

    java.lang.Object
      com.opensymphony.xwork2.interceptor.AbstractInterceptor
          org.apache.struts2.interceptor.FileUploadInterceptor

All Implemented Interfaces:
  Interceptor, Serializable

    public class FileUploadInterceptor

extends AbstractInterceptor

Interceptor that is based off of `MultiPartRequestWrapper`, which is automatically applied for any request that includes a file. It adds the following parameters, where [File Name] is the name given to the file uploaded by the HTML form:

- [File Name] : File - the actual File

- [File Name]ContentType : String - the content type of the file

- [File Name]FileName : String - the actual name of the file uploaded (not the HTML name)

You can get access to these files by merely providing setters in your action that correspond to any of the three patterns above, such as setDocument(File document), setDocumentContentType(String contentType), etc.
See the example code section.

This interceptor will add several field errors, assuming that the action implements `ValidationAware`. These error messages are based on several i18n values stored in struts-messages.properties, a default i18n file processed for all i18n requests. You can override the text of these messages by providing text for the following keys:

- struts.messages.error.uploading - a general error that occurs when the file could not be uploaded

- struts.messages.error.file.too.large - occurs when the uploaded file is too large

- struts.messages.error.content.type.not.allowed - occurs when the uploaded file does not match the expected content types specified

- struts.messages.error.file.extension.not.allowed - occurs when the uploaded file does not match the expected file extensions specified

Interceptor parameters:

- maximumSize (optional) - the maximum size (in bytes) that the interceptor will allow a file reference to be set on the action. Note, this is not related to the various properties found in struts.properties. Default to approximately 2MB.

- allowedTypes (optional) - a comma separated list of content types (ie: text/html) that the interceptor will allow a file reference to be set on the action. If none is specified allow all types to be uploaded.

- allowedExtensions (optional) - a comma separated list of file extensions (ie: .html) that the interceptor will allow a file reference to be set on the action. If none is specified allow all extensions to be uploaded.

Extending the interceptor:

You can extend this interceptor and override the acceptFile method to provide more control over which files are supported and which are not.

Example code:

     <action name="doUpload" class="com.example.UploadAction">
         <interceptor-ref name="fileUpload"/>
         <interceptor-ref name="basicStack"/>
         <result name="success">good_result.jsp</result>
     </action>

You must set the encoding to `multipart/form-data` in the form where the user selects the file to upload.

       <s:form action="doUpload" method="post" enctype="multipart/form-data">
           <s:file name="upload" label="File"/>
           <s:submit/>
       </s:form>

And then in your action code you'll have access to the File object if you provide setters according to the naming convention documented in the start.

        package com.example;

        import java.io.File;
        import com.opensymphony.xwork2.ActionSupport;

        public UploadAction extends ActionSupport {
           private File file;
           private String contentType;
           private String filename;

           public void setUpload(File file) {
              this.file = file;
           }

           public void setUploadContentType(String contentType) {
              this.contentType = contentType;
           }

           public void setUploadFileName(String filename) {
              this.filename = filename;
           }

           public String execute() {
              //...
              return SUCCESS;
           }
      }

See Also:
  Serialized Form

Field Summary
`protected Set<String>` | `allowedExtensionsSet`
`protected Set<String>` | `allowedTypesSet`
`protected static Logger` | `LOG`
`protected Long` | `maximumSize`

Constructor Summary
`FileUploadInterceptor()`

Method Summary
`protected boolean` | `acceptFile(Object action, File file, String filename, String contentType, String inputName, ValidationAware validation)` Override for added functionality.
`protected String` | `getTextMessage(Object action, String messageKey, String[] args)`
`protected String` | `getTextMessage(String messageKey, String[] args)`
`String` | `intercept(ActionInvocation invocation)`
`void` | `setAllowedExtensions(String allowedExtensions)` Sets the allowed extensions
`void` | `setAllowedTypes(String allowedTypes)` Sets the allowed mimetypes
`void` | `setContainer(Container container)`
`void` | `setMatcher(ContentTypeMatcher matcher)`
`void` | `setMaximumSize(Long maximumSize)` Sets the maximum size of an uploaded file

Methods inherited from class com.opensymphony.xwork2.interceptor.AbstractInterceptor
`destroy, init`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### LOG

    protected static final Logger LOG

### maximumSize

    protected Long maximumSize

### allowedTypesSet

    protected Set<String> allowedTypesSet

### allowedExtensionsSet

    protected Set<String> allowedExtensionsSet

Constructor Detail

### FileUploadInterceptor

    public FileUploadInterceptor()

Method Detail

### setMatcher

    public void setMatcher(ContentTypeMatcher matcher)

### setContainer

    public void setContainer(Container container)

### setAllowedExtensions

    public void setAllowedExtensions(String allowedExtensions)

  Sets the allowed extensions

  Parameters:
    `allowedExtensions` - A comma-delimited list of extensions

### setAllowedTypes

    public void setAllowedTypes(String allowedTypes)

  Sets the allowed mimetypes

  Parameters:
    `allowedTypes` - A comma-delimited list of types

### setMaximumSize

    public void setMaximumSize(Long maximumSize)

  Sets the maximum size of an uploaded file

  Parameters:
    `maximumSize` - The maximum size in bytes

### intercept

    public String intercept(ActionInvocation invocation)
                     throws Exception

  Specified by:
    `intercept` in interface `Interceptor`
  Specified by:
    `intercept` in class `AbstractInterceptor`
  Throws:
    `Exception`

### acceptFile

    protected boolean acceptFile(Object action,
                                 File file,
                                 String filename,
                                 String contentType,
                                 String inputName,
                                 ValidationAware validation)

  Override for added functionality. Checks if the proposed file is acceptable based on contentType and size.

  Parameters:
    `action` - - uploading action for message retrieval.
    `file` - - proposed upload file.
    `contentType` - - contentType of the file.
    `inputName` - - inputName of the file.
    `validation` - - Non-null ValidationAware if the action implements ValidationAware, allowing for better logging.
  Returns:
    true if the proposed file is acceptable by contentType and size.

### getTextMessage

    protected String getTextMessage(String messageKey,
                                    String[] args)

### getTextMessage

    protected String getTextMessage(Object action,
                                    String messageKey,
                                    String[] args)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000–2017 Apache Software Foundation. All rights reserved.